package com.yihaomen.annotation;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


@Aspect
public class LogAspect {

    private static final Logger log = LoggerFactory.getLogger(LogAspect.class);


    @Around("@annotation(com.yihaomen.annotation.Log)")
    public Object memoize(ProceedingJoinPoint pjp) throws Throwable {
       
        
        log.info("class name: " + pjp.getSignature().getDeclaringType().getName());
        log.info("method name: " + pjp.getSignature().getName());
        
        for(Object obj : pjp.getArgs()){
        	log.info("parameters: " + obj);
        }
        
       
        Object result = pjp.proceed();
        log.info("end of exec function");
           
        return result;
    }
}
